# Tutorial

:project Programming

## Introdução

:overlay

:position 30,30,40,40

:navigate projects.code.console

### Programando

Neste curso tutorial, aprenderemos sobre programação em **microScript**.

Clique no botão "próximo" para continuar: 

:navigate projects.code.console

:highlight #tutorial-window .navigation .next

## Console

:navigate projects.code.console

:position 60,30,40,50

### Console

Como introdução à programação, vamos brincar com o console microStudio. O console permite conversar com o computador digitando texto (código) e lendo as respostas do computador. 

:highlight #terminal

## Entrada do console

:navigate projects.code.console

Para iniciar a programação, clique na área de entrada do console (destacada). 

:highlight #terminal-input-line

:auto

## Digite uma palavra

:navigate projects.code.console

### Digite uma palavra

Digite uma palavra com seu teclado, tal como:

```
hello
```

Em seguida, valide sua entrada pressionando a tecla [Enter] ou [⏎]

:auto #terminal-input

## Resposta

:navigate projects.code.console

Se você digitou ```hello```, microScript respondeu com ```0```.

Não fique chateado, o computador não quis ser rude! Um computador não é tão inteligente quanto você pensa. Ele pode trabalhar duro, mas precisa que você expresse exatamente o que espera dele.

Programar significa dizer ao computador o que fazer, usando uma linguagem que ele possa entender. 

## Resposta 2

:navigate projects.code.console

O computador respondeu com ```0``` porque não conhece ```hello```. Ele procurou em sua memória por uma *variável* que seria chamada assim, mas não encontrou nada.

Assim, respondeu ```0``` que para ele também significa nada, não encontrado, desconhecido. Vamos tentar ensinar algo, digite:

```
hello = 5
```

:auto #terminal-input

## Atribuindo um valor a uma variável

:navigate projects.code.console

Ao validar esta linha, nós apenas * atribuímos * o valor ```5``` para a *variável* ```hello```. O computador criou uma célula em sua memória, denominada "hello" e na qual armazenou o valor 5.

Agora podemos perguntar de novo: 

```
hello
```

O console respondeu 5! Parece que finalmente aprendeu alguma coisa.

## Fazendo cálculos

:navigate projects.code.console

Será que é possível calcular? Vamos tentar:

```
1+1
```

Impressionante, não é mesmo? Agora tente:

```
hello*2
```

OK, isso é muito interessante, parece que ele pode usar sua memória e fazer cálculos *simultaneamente*. Certamente podemos tirar proveito disso. É hora de passar para o próximo tutorial para aprender mais sobre variáveis. 
