# Урок

:project Programming

## Циклы

:overlay

:position 30,30,40,40

:navigate projects.code.console

### Циклы

Цикл - это специальный шаблон программирования, позволяющий повторять набор инструкций много раз. Циклы могут быть полезны для того, чтобы выполнить обработку всех элементов в списке или для повторения работы до тех пор, пока не будет выполнено определенное условие.

## Цикл ``for``

:navigate projects.code.console

:position 55,30,40,40

### Цикл ``for``

Ключевое слово ``for`` позволяет вам создать цикл с переменной, значение которой будет меняться при каждом повторении цикла. Например:

```
for i=1 to 10
  print(i)
end
```

В приведенном выше цикле переменная ``i`` будет последовательно принимать значения 1, 2, 3... до 10. Для каждого из этих значений будет вызываться функция ``print(i)``. Как и ``function`` или ``if``, цикл должен быть закрыт ключевым словом ``end``.

## Цикл ``for``

:navigate projects.code.console

:position 55,30,40,40

### Инкремент

Ключевое слово ``by`` позволяет определить *инкремент*, используемый для каждой итерации, т.е. на сколько должно быть увеличено значение итерационной переменной:

```
for i=1 to 10 by 2
  print(i)
end
```

Скопируйте приведенный выше пример и посмотрите результат. Вы также можете попробовать другие значения.

## Инкремент

:navigate projects.code.console

:position 55,30,40,40

### Инкремент

Вот так правильно вести обратный отсчет:

```
for i=10 to 0 by -1
  print(i)
end
```

## Итерация в списке

:navigate projects.code.console

:position 55,30,40,40

### Итерация в списке

Вот как выполнить обработку всех элементов списка с использованием ``for``, за которым следует ключевое слово ``in``:

```
list = [ "собака", "кот", "мышь" ]

for animal in list
  print(animal)
end
```

Это называется *итерацией* по списку.

## До тех пор, пока

:navigate projects.code.console

:position 55,30,40,40

### Повторять до тех пор, пока (...)

Инструкция ``while`` позволяет вам повторять последовательность операций до тех пор, пока условие остается истинным. Например:

```
i = 1

while i < 1000
  print(i)
  i *= 2
end
```

Операции в описанном выше цикле будут повторяться до тех пор, пока переменная i остается ниже 1000. Как только условие больше не выполняется, происходит выход из цикла и продолжается выполнение остальной части программы.


## Предостережение

:navigate projects.code.console

:position 55,30,40,40

### Предостережение

Когда вы пишете цикл ``for`` или ``while``, не забудьте закрыть его с помощью ключевого слова ``end``. Также спросите себя об условии остановки:
остановится ли мой цикл в какой-то момент? Будьте осторожны, чтобы не создать бесконечный цикл, как в приведенном ниже примере:

```
i = 1

while i < 1000
  print(i)
end
```

В приведенном выше примере цикл никогда не остановится, поскольку ничто не может изменить значение ``i`` в теле цикла. *microScript* предупредит вас об ошибке тайм-аута.
